local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mapMod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "HELETONKIR_COAST_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -11,
	MaxHeight = 63,
	VillagePathList = {
		{
			Entrance = { 230, 0, 1013 },
			Exit = { 10, 0, 73 },
		},
		{
			Entrance = { 230, 0, 1013 },
			Exit = { 10, 0, 813 },
		},
		{
			Entrance = { 720, 0, 13 },
			Exit = { 640, 0, 13 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 550 , 20 , 716 },
			Orientation = { 0.0, -15.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 544 , 21 , 713 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 536 , 21 , 709 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 529 , 22 , 707 },
			Orientation = { 0.0, 10.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 550 , 24 , 710 },
			Orientation = { 0.0, 160.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 543 , 28 , 710 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 547 , 25 , 705 },
			Orientation = { 0.0, 165.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 539 , 24 , 703 },
			Orientation = { 0.0, -160.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 144 , 13 , 424 },
			Orientation = { 0.0, 180.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 10
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 151 , 13 , 426 },
			Orientation = { 0.0, 176.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 160 , 13 , 426 },
			Orientation = { 0.0, 170.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 12
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 150 , 13 , 431 },
			Orientation = { 0.0, -60.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 197 , 16 , 419 },
			Orientation = { 0.0, -110.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 14
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 204 , 16 , 416 },
			Orientation = { 0.0, -125.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 15
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 201 , 17 , 421 },
			Orientation = { 0.0, 30.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 16
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 100 , 26 , 420 },
			Orientation = { 0.0, 90.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 17
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 98 , 26 , 421 },
			Orientation = { 0.0, 76.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 18
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 97 , 27 , 417 },
			Orientation = { 0.0, -120.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 19
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 936 , 12 , 184 },
			Orientation = { 0.0, -100.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 20
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 941 , 12 , 180 },
			Orientation = { 0.0, -105.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 21
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 945 , 14 , 178 },
			Orientation = { 0.0, -95.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 22
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 948 , 17 , 175 },
			Orientation = { 0.0, -90.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 23
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 955 , 15 , 87 },
			Orientation = { 0.0, -86.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 24
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 958 , 18 , 85 },
			Orientation = { 0.0, -90.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 25
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 958 , 17 , 77 },
			Orientation = { 0.0, -79.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 26
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 965 , 23 , 82 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 27
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 241 , 12 , 756 },
			Orientation = { 0.0, 170.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 28
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 234 , 11 , 756 },
			Orientation = { 0.0, 165.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 29
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 227 , 11 , 753 },
			Orientation = { 0.0, 160.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 30
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 221 , 11 , 756 },
			Orientation = { 0.0, -175.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 31
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 247 , 12 , 759 },
			Orientation = { 0.0, 180.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 32
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 211 , 13 , 707 },
			Orientation = { 0.0, 20.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 33
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 217 , 12 , 703 },
			Orientation = { 0.0, 45.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 34
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 208 , 15 , 703 },
			Orientation = { 0.0, 160.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 35
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 204 , 17 , 707 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 36
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 201 , 22 , 702 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 37
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 211 , 14 , 699 },
			Orientation = { 0.0, 180.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 38
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 444 , 14 , 961 },
			Orientation = { 0.0, -150.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 39
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 440 , 14 , 965 },
			Orientation = { 0.0, -145.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 40
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 444 , 14 , 965 },
			Orientation = { 0.0, 0.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 41
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 798 , 3 , 582 },
			Orientation = { 0.0, -135.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 42
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 795 , 4 , 587 },
			Orientation = { 0.0, -130.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 43
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 793 , 5 , 590 },
			Orientation = { 0.0, -125.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 44
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 805 , 0 , 584 },
			Orientation = { 0.0, -160.0 , 0.0}
		},
		{
			-- creating Mineral Deposit 45
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 788 , 6 , 594 },
			Orientation = { 0.0, -110.0 , 0.0}
		},
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.5,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 1.0,
							Max = 1.5
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
